import { type Ref } from 'vue-demi';
export type Watcher<P> = {
    keys?: (keyof P)[];
    immediate?: boolean;
    deep?: boolean;
};
export interface UseTableList<T = any, P = any, D = any> {
    request: {
        api: (params: P) => Promise<T>;
        params?: P;
        pageNumKey?: string;
        pageSizeKey?: string;
        handleParams?: (params: P) => P;
        watcher?: Watcher<P>;
    };
    response?: {
        listKey?: string;
        totalKey?: string;
        hasPage?: (res: D) => boolean;
        append?: boolean;
        responseHandler?: (res: D) => any;
    };
}
export declare const useTableList: <T = any, P extends object = any, D = any>(config: UseTableList<T, P, D>) => {
    params: Ref<P>;
    tableData: Ref<T[]>;
    tableTotal: Ref<number>;
    tableLoading: Ref<boolean>;
    isLastPage: Ref<boolean>;
    handleSearch: (pageNum?: number) => Promise<void>;
    handleReset: () => Promise<void>;
    handleSizeChange: (pageSize: number) => Promise<void>;
    handleCurrentChange: (pageNum: number) => Promise<void>;
};
